/*
 * 残課題
 *  絵
 *  発音記号表示
 * Future work
 * ・発音（ビリーの声で）
 * ・自然言語エンジンによる問題文生成、解答チェック
 * ・音声認識
 */
/* 単語数 */
words = 12000;

/****************************************************************************************
 * セーブデータの実装
 ****************************************************************************************/
/* 点数データベース */
pointdb = new Array(words/10);

/* 通常0 */
debug = 1;

/*----------------------------------------------------------------------------------------
 getCookie()
 setCookie()
 clearCookie()
  tohohoより転載
  詳細不明だがstr=getCookie("KEY")とかsetCookie("KEY","hoge")とかで使える
 ----------------------------------------------------------------------------------------*/
function getCookie(key,  tmp1, tmp2, xx1, xx2, xx3) {
    tmp1 = " " + document.cookie + ";";
    xx1 = xx2 = 0;
    len = tmp1.length;
    while (xx1 < len) {
        xx2 = tmp1.indexOf(";", xx1);
        tmp2 = tmp1.substring(xx1 + 1, xx2);
        xx3 = tmp2.indexOf("=");
        if (tmp2.substring(0, xx3) == key) {
            return(unescape(tmp2.substring(xx3 + 1, xx2 - xx1 - 1)));
        }
        xx1 = xx2 + 1;
    }
    return("");
}
function setCookie(key, val, tmp) {
    tmp = key + "=" + escape(val) + "; ";
    // tmp += "path=" + location.pathname + "; ";
    tmp += "expires=Tue, 31-Dec-2030 23:59:59; ";
    document.cookie = tmp;
}
function clearCookie(key) {
    document.cookie = key + "=" + "xx; expires=Tue, 1-Jan-1980 00:00:00;";
}

/*---------------------------------------------------------------------------------------
 load_save_data()
  cookieのセーブデータをpointdbにロードする。
  データの修復機能も備える。
  a5game.htmlの起動時に実行される。
 入力
  cookie
   データ名：savedata
   Lv.1 Stage1からLv.(words/100) Stage10までの点数/10が文字列で羅列されている
   100点の場合は'a'が格納されている
   データサイズが(words/10)以外の場合、値をゼロの羅列で初期化する
 出力
  pointdb[(words/10)]
   Lv.1 Stage1からLv.(words/100) Stage10までの点数が整数で羅列されている
 pointdbのライフサイクル
  a5game.html起動時にcookieの値を基に初期化され、
  ステージ一覧を表示するときのバーを書くために参照され、
  採点時に最高得点を上回ったときに書き換えられる。
 ----------------------------------------------------------------------------------------*/
function load_save_data(){
  var i = 0; // iterator
  var fix = 0; // データを修復する必要がある場合1になる

  // cookieのセーブデータをbufにロードする。
  var buf = getCookie("savedata"); // buf:バッファ(点数/10)

  // bufのサイズが(words/10)バイト以外だった場合、bufを(words/10)個の'0'で埋める。
  {
    var len = buf.length; // len:セーブデータのサイズ
    if( len != words/10 ){
      buf = "";
      for( i = 0; i < words/10; ++i ){
        buf += "0";
      }
      fix = 1;
    }
  }

  // bufに{'0'-'9'および'a'}以外の文字が含まれていた場合、bufを(words/10)個の'0'で埋める。
  {
    var flag = 0; // {'0'-'9'および'a'}以外の文字を検出したときに1
    for( i = 0; i < words/10; ++i ){ // この時点でbufの長さは(words/10)になっている
      var c = buf.charAt(i);
      if( ( '0'<=c && c<='9' ) || 'a'==c ){
      }
      else{
        flag = 1;
        break;
      }
    }
    if( flag ){
      buf = "";
      for( i = 0; i < words/10; ++i ){
        buf += "0";
      }
      fix = 1;
    }
  }

  if( fix == 1 ){
    // bufとcookieの同期を取る（データ修復）
    setCookie("savedata",buf);
  }

  // bufのそれぞれのバイトについて、以下のルールでpointdbに値を読み込む。
  // ・セーブデータが'a'だった場合、100をpointdbに格納
  // ・それ以外の場合、(バッファの内容-'0')*10をpointdbに格納
  for( i = 0; i < words/10; ++i ){
    var c = buf.charAt( i ); // c:バッファ（1文字分）
    pointdb[i] = ( c == 'a' ? 100 : (c - '0') * 10 );
  }
}

/*---------------------------------------------------------------------------------------
 update_save_data()
  最高得点を更新した際に呼ばれ、得点をバッファ経由でcookieに保存する
 入力
  level
   レベル(1～(words/100))
  stage
   ステージ(1～10)
  point
   点数(0～100)
 出力
  cookie
   Lv.1 Stage1からLv.(words/100) Stage10までの点数が文字列で羅列されている
   10点の場合は'a'が格納されている
  pointdb
   Lv.1 Stage1からLv.(words/100) Stage10までの点数を持つ配列
 ----------------------------------------------------------------------------------------*/
function update_save_data( level, stage, point ){
  pointdb[ ( level - 1 ) * 10 + ( stage - 1 ) ] = point;
  var str = getCookie( "savedata" );
  var buf = "";
  var i = 0;
  for( i = 0; i < words/10; ++i ){
    if( i == ( level - 1 ) * 10 + ( stage - 1 ) ){
      buf += ( point == 100 ? 'a' : point / 10 );
    }
    else{
      buf += str.charAt( i );
    }
  }
  setCookie( "savedata", buf );
}

/*---------------------------------------------------------------------------------------
 clear_all()  デバッグ用
  pointdbに"0"を格納
  cookieの"savedata"を消去
 ----------------------------------------------------------------------------------------*/
function clear_all(){
  var i;
  var str;
  for( i = 0; i < words/10; ++i ){
    pointdb[i] = "0";
  }
  clearCookie("savedata");
}

/*---------------------------------------------------------------------------------------
 fill(level)  デバッグ用
  levelで指定したレベルを満点にする
 入力
  level(1～(words/100))
 出力
  pointdb
  cookie
 ----------------------------------------------------------------------------------------*/
function fill( level ){
  var i = 0;
  var str = "";
  var buf = "";
  str = getCookie("savedata");
  for( i = 0; i < 10; ++i ){
    pointdb[(level-1)*10+i] = 100;
  }
  for( i = 0; i < words/10; ++i ){
    if( Math.floor(i/10) == (level-1) ){
      buf += 'a';
    }
    else{
      buf += str.charAt(i);
    }
  }
  setCookie("savedata", buf);
}

/*-------------------------------------------------------------------------------------
 init_main()
  トップページにクリアしたステージ数を表示
 --------------------------------------------------------------------------------------*/
function init_main(){
  var str = getCookie("savedata");
  var i = 0;
  var total_stages = words / 10;
  var clear_stages = 0;
  var err = false;
  document.getElementById("stages").innerHTML = words;
//  document.getElementById("stages").innerHTML = total_stages;
  if( str.length != total_stages ){
    document.getElementById("cleared").innerHTML = "0";
    return;
  }
  for( i = 0; i < total_stages; ++i ){
    if( ( str.charAt(i) >= '0' && str.charAt(i) <= '9' )
    || str.charAt(i) == 'a' ){
      if( str.charAt(i) == 'a' ){
        clear_stages += 10;
      }
      else{
        clear_stages += str.charAt(i) - '0';
      }
    }
    else{
      clear_stages = 0;
      break;
    }
  }
/*
  for( i = 0; i < total_stages; ++i ){
    if( ( str.charAt(i) >= '0' && str.charAt(i) <= '9' )
    || str.charAt(i) == 'a' ){
      if( str.charAt(i) == 'a' ){
        clear_stages++;
      }
    }
    else{
      clear_stages = 0;
      break;
    }
  }
*/
  document.getElementById("cleared").innerHTML = clear_stages;
  document.getElementById("dbg").innerHTML = str;
}

/****************************************************************************************
 * ゲームの主幹部分
 * コーディングの負担を軽減するため、レベル・ステージごとにページを持たず、
 * 一つのページで3つの階層を実装する。
 * 階層1
 *  すべてのレベルを表示
 * 階層2
 *  一つのレベルを表示
 * 階層3
 *  一つのステージを表示
 ****************************************************************************************/
// 起動時に1、それ以外は0
first_load = 1;

/*---------------------------------------------------------------------------------------
 levels()
  レベルの一覧を表示する
  階層1
 入力
  なし
 出力
  HTMLで記述された表（id:"tbl"）
 ----------------------------------------------------------------------------------------*/
function levels(){
  if( first_load == 1 ){
    load_save_data(); // セーブデータをロード
    first_load = 0;
  }
  var i = 0;
  var j = 0;
  var k = 0;
  var str = "";
  var cols = 5;
  str = "<table width=1024>"; // heightは単語数に依存
  str += "<tr height=70><th colspan=" + cols + " align=center style=\"color:#8888FF\"><big><big><big>レベル一覧</big></big></big></th></tr>";
  // レベルを cols x (words/100/cols) のマトリクスで表示
  var rows = words / 100 / cols;
  for( i = 0; i < rows; ++i ){
    str += "<tr height=40>";
    for( j = 0; j < cols; ++j ){
      var level = ( i * cols ) + j + 1; // level : 1～(words/100)
      var clear = 0; // そのレベルの全てのステージが満点だったら1になる
      var n = 0; // クリアしたステージの数
      // 全クリしたレベルは表示を変える
      for( k = 0; k < 10; ++k ){
        if( pointdb[(level-1) * 10 + k] == 100 ){
          n++;
        }
      }
      if( n == 10 ){
        clear = 1;
      }
      // レベルをクリックするとinit_menu()が起動する
      if( clear == 0 ){
        str +=
          "<td align=center onclick=\"init_menu(" + level + ")\">" +
            "<u>" +
              "<big>" +
                "<b>" +
                  "<a href=\"#\" style=\"color:blue\">" +
                    "レベル" + level +
                  "</a>" +
                "</b>" +
              "</big>" +
            "</u>" +
          "</td>";
      }
      else{ // そのレベルの全ステージが満点の場合、表示を強調しない
        str +=
          "<td align=center onclick=\"init_menu(" + level + ")\">" +
            "<u>" +
              "<big>" +
                "<b>" +
                  "<a href=\"#\" style=\"color:#AAAAFF\">" +
                    "レベル" + level +
                  "</a>" +
                "</b>" +
              "</big>" +
            "</u>" +
          "</td>";
      }
    }
    str += "</tr>";
  }
  str += "<tr><td height=10></td></tr>";
  str += "<tr><td colspan=4>Ads by google</td>" + 
         "<td align=center><a href=\"index.html\"><トップページに戻る</a></td></tr>"
  // マス幅指定
  str += "<tr>";
  for( i = 0; i < cols; ++i ){
    str += "<td width=" + Math.floor(1024/cols) + "></td>";
  }
  str += "</tr>";
  str += "</table>";
  if( debug ){
    str += "<br>";
    str += "<a href=\"#\" onclick=\"fill(1)\">Lv.1を満点にする</a>";
    str += "<br>";
    str += "<a href=\"#\" onclick=\"clear_all()\">" +
      "初期化" +
      "</a>";
  }
  document.getElementById("tbl").innerHTML = str;
}

/*---------------------------------------------------------------------------------------
 init_menu()
 与えられたレベルのステージ一覧を作成し表示する
 バーが背景を隠す画面はここで出力される
 階層2
 入力
  level レベル(1～(words/100))
 出力
  HTMLで記述された表（id:"tbl"）
 ----------------------------------------------------------------------------------------*/
function init_menu(level){
  var i = 0; // iterator
  var str = ""; // HTMLで記述された表
  // 表の画角はニコ動と同程度の1024x768。背景画像も原則として同じ画角とするが一応右寄せして、高得点を取らなければ見えないようにする。
  str = "<table width=1024 style=\"background:url(img/" + level + ".gif) no-repeat right\">";
  str +=
    // いちばん上にレベルを表示
    "<tr height=70><th colspan=4 height=50 style=\"color:#8888FF; text-align:center; font-size:large;\"><big><big>小４英語　レベル" + level + "</big></big></th></tr>" +
    // その右下に「最高得点」を表示
    "<tr height=50><td colspan=3></td><td style=\"color:#8888FF; text-align:center;\">最高得点</td></tr>";
  // ステージごとのステータスを表示
  for( i = 0; i < 10; ++i ){ // i:ステージ番号-1
    str +=
      "<tr>" +
        "<td width=200 height=40 align=center onclick=\"remember(" + level + "," + ( i + 1 ) + ")\">" + // 入れ子のスクリプトに即値をセット
          "<u>" +
            "<big>" +
              "<a href=\"#\" style=\"color:blue\">" +
                "Stage" + (i+1) + // ステージ番号表示
              "</a>" +
            "</big>" +
          "</u>" +
        "</td>" +
        "<td colspan=2 width=700>" + // バー表示
          "<span style=\"position:relative; top:-16px\">" + // この行はおまじない
            "<span style=\"position:absolute; top:0px;" +
              " left:" + Math.floor( pointdb[( level - 1 ) * 10 + i ] / 100 * 700 ) + "px;" +
              " width:" + ( 700 - Math.floor( pointdb[( level - 1 ) * 10 + i ] / 100 * 700 ) ) + "px;" +
              " height:30px; background-color:#AAFFAA; \">" +
            "</span>" +
          "</span>" +
        "</td>" +
        "<td style=\"text-align:center\">" +
          pointdb[ ( level - 1 ) * 10 + i ] + "/" + "<small>100</small>" + // 点数表示
        "</td>" +
      "</tr>";
  }
  str += "<tr><td height=10></td></tr>";
  str += "<tr><td colspan=2 width=700>Ads by google</td>" + // Ads by google
    "<td colspan=2 align=center>" +
      "<a href=\"index.html\"><<トップページに戻る</a><br>" +
      "<a href=\"a5game.html\"><レベル一覧に戻る</a>" +
    "</td>" +
  "</tr>";
  // マス幅指定
  str += "<tr height=0><td width=200></td><td width=500></td><td width=250></td><td width=74></td></tr>";
  str += "</table>";
  document.getElementById("tbl").innerHTML = str;
}

/*---------------------------------------------------------------------------------------
 OnLink(),OffLink()
  発音記号の表示
  階層3
  http://www.sky.sannet.ne.jp/masapine/java_link8.html
 画面概要
  「覚えてね」画面で英単語にカーソルを合わせると発音記号をポップアップする。
 入力
  Msg : メッセージを表示するオブジェクト
  num : 単語の番号
  mX,mY : 座標(IE)
  nX,nY : 座標(NN/N6)
 出力
  発音記号
 ----------------------------------------------------------------------------------------*/
var IE = 0,NN = 0,N6 = 0;
if(document.all) IE = true;
else if(document.layers) NN = true;
else if(document.getElementById) N6 = true;

function OnLink(Msg,num,mX,mY,nX,nY){
  var pX = 0,pY = 0;
  var sX = -10,sY = 30;
  if(IE){
    MyMsg = document.all(Msg).style;
    MyMsg.visibility = "visible";
  }
  if(NN){
    MyMsg = document.layers[Msg];
    MyMsg.visibility = "show";
  }
  if(N6){
    MyMsg = document.getElementById(Msg).style;
    MyMsg.visibility = "visible";
  }
  if(IE){
    pX = document.body.scrollLeft;
    pY = document.body.scrollTop;
    MyMsg.left = mX + pX + sX;
    MyMsg.top = mY + pY + sY;
  }
  if(NN || N6){
    MyMsg.left = nX+ sX;
    MyMsg.top = nY + sY;
  }
  document.getElementById(Msg).innerHTML = pron[num];
}

function OffLink(Msg){
  if(IE) document.all(Msg).style.visibility = "hidden";
  if(NN) document.layers[Msg].visibility = "hide";
  if(N6) document.getElementById(Msg).style.visibility = "hidden";
}

/*---------------------------------------------------------------------------------------
 remember()
 「覚えてね」画面の表示
  階層3
 画面概要
  「覚えてね」と、10組の和訳、単語、発音を表示
  [テスト]をクリックするとtest_start()を起動しテスト画面に遷移
 入力
  level レベル(1～(words/100))
  stage ステージ(1～10)
 出力
  HTMLで記述された表（id:"tbl"）
 ----------------------------------------------------------------------------------------*/
function remember(level,stage){
  var i = 0;
  var str = "";
  str += "<span id=\"L1\" class=\"c1\"></span>";
  str += "<table cellspacing=0 width=1024>";
  str += "<tr height=70><td colspan=4 align=center style=\"color:#8888FF\"><big><big><big>覚えよう　　Lv." + level + "　Stage:" + stage + "</big></big></big></td></tr>";
  for( i = 0; i < 10; ++i ){
    if( i % 2 ){
      str += "<tr height=40 bgcolor=#FFCCCC>";
    }
    else{
      str += "<tr height=40 bgcolor=#CCFFFF>";
    }
    str += "<td>　" + ( i + 1 ) + "." + "</td>" + "<td>" +
           "<a href=\"http://www.google.co.jp/search?ie=UTF-8&oe=UTF-8&sourceid=navclient&q=" + 
             // encodeURIは文字列をutf8に変換する。これはIEとcrhome用で、firefoxでは省略できる。
	     // target="_blank"はリンク先を別窓(IE)または別タブ(crhome)で表示させる。firefoxはこの設定の有無に関わらず、別タブで表示する。
	     //  別窓・別タブで表示させないと、[戻る]を押したときに階層1まで戻ってしまう(IE,chrome)
             encodeURI( word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 ] + "とは" ) + "\" target=\"_blank\">" +
             word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 ] + "</a>" +
           "</td>" +
           "<td>" +
             "<a href=\"http://eow.alc.co.jp/" + word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 + 1 ] + "\" " +
                 "onMouseOver=\"OnLink(\'L1\'," + ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) + ", event.x,event.y,event.pageX,event.pageY)\" onMouseOut=\"OffLink(\'L1\')\"" +
                " target=\"_blank\">" +
               word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 + 1 ] +
             "</a>" +
           "</td>";
    if( i == 0 ){
      str +=
        "<td rowspan=10 align=center bgcolor=white>" +
          "<a href=\"#\" style=\"border:0px\">" + // マウスカーソルを手の形にするため
            "<img src=\"img/test_start.gif\" onclick=\"test_start(" + level + "," + stage + ")\">" +
          "</a>" +
        "</td>";
    }
    str += "</tr>";
  }
  str += "<tr><td height=10></td></tr>";
  str +=
    "<tr>" +
      "<td colspan=3>" +
        "Ads by google" +
      "</td>" +
      "<td>" +
        "<a href=\"index.html\"><<<トップページに戻る</a><br>" +
        "<a href=\"a5game.html\"><<レベル一覧に戻る</a><br>" +
        "<a href=\"#\" onclick=\"init_menu(" + level + ")\">" +
          "<ステージ一覧に戻る" +
        "</a>" +
      "</td>" +
    "</tr>";
  // マス幅指定
  str += "<tr><td width=100></td><td width=250></td><td width=250></td><td width=424></td>";
  str += "</table>";
  document.getElementById("tbl").innerHTML = str;
}

/*---------------------------------------------------------------------------------------
 test_start()
  テスト画面の表示
  階層3
 画面概要
  指定されたlevelとstageに対応する問題を出す
  [採点]をクリックすると採点画面に遷移
 入力
  level レベル(1～(words/100))
  stage ステージ(1～10)
 出力
  HTMLで記述された表（id:"tbl"）
 ----------------------------------------------------------------------------------------*/
function test_start(level,stage){
  var i = 0;
  var str = "";
  str = "<table cellspacing=0 width=1024>";
  str += "<tr height=70><th colspan=4 align=center style=\"color:#8888FF;\"><big><big><big>テスト　Lv." + level + "　Stage:" + stage + "</big></big></big></th></tr>";
  str += "<tr height=0><td colspan=3></td>" +
        "<td rowspan=11 align=center bgcolor=white>" +
          "<a href=\"#\" style=\"border:0px\">" + // マウスカーソルを手の形にするため
            "<img src=\"img/saiten.gif\" onclick=saiten(" + level + "," + stage + ")>" +
          "</a>" +
        "</td>";
  for( i = 0; i < 10; ++i ){
    if( i % 2 ){
      str += "<tr height=40 bgcolor=#FFCCCC>";
    }
    else{
      str += "<tr height=40 bgcolor=#CCFFFF>";
    }
    str +=
        "<td>" +
          "　" + ( i + 1 ) + "." +
        "</td>" +
        "<td>" +
          // 問題欄の表示
          word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 ] +
        "</td>" +
        "<td>" +
          // 解答欄の表示
          "<form style=\"display:inline\">" + // formで改行させない裏技
            "<input size=45 type=text name=\"" + "ans" + i + "\"" + " value=\"" + word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 + 1 ].charAt(0) + "\">";
    str +=
          "</form>" +
        "</td>";
    str +=
      "</tr>";
  }
  str += "<tr><td height=10></td></tr>";
  str +=
    "<tr>" +
      "<td colspan=3>" +
        "Ads by google" +
      "</td>" +
      "<td>" +
        "<a href=\"index.html\"><<<<トップページに戻る</a><br>" +
        "<a href=\"a5game.html\"><<<レベル一覧に戻る</a><br>" +
        "<a href=\"#\" onclick=\"init_menu(" + level + ")\">" +
          "<<ステージ一覧に戻る" +
        "</a><br>" +
        "<a href=\"#\" onclick=\"remember(" + level + "," + stage + ")\">" +
          "<単語一覧に戻る" +
        "</a>" +
      "</td>" +
    "</tr>";
  // マス幅指定
  str += "<tr><td width=100></td><td width=250></td><td width=250></td><td width=424></td>";
  str += "</table>";
//console.log(str);
  document.getElementById("tbl").innerHTML = str;
}

/*---------------------------------------------------------------------------------------
 saiten()
  採点画面の表示
  階層3
 画面概要
  ans0～9と正解を照合し、結果と正解と点数を表示
  [やり直す]をクリックすると「覚えてね画面」に遷移
  [次のステージ]をクリックすると次のステージの「覚えてね画面」に遷移
 入力
  level レベル(1～(words/100))
  stage ステージ(1～10)
 出力
  HTMLで記述された表（id:"tbl"）
 ----------------------------------------------------------------------------------------*/
function saiten(level,stage){
  var i = 0; // iterator
  var point = 0; // 点数
  var str = ""; // HTMLで記述された表
  // 画角1024x768
  str = "<table cellspacing=0 width=1024>";
  // キャプション
  str +=
    "<tr height=70>" +
      "<th colspan=4 align=center style=\"color:#8888FF;\">" +
        "<big>" +
          "<big>" +
            "<big>" +
              "採点結果　Lv." + level + "　Stage:" + stage +
            "</big>" +
          "</big>" +
        "</big>" +
      "</th>" +
    "</tr>";
  // それぞれの問題・解答・正解、点数
  for( i = 0; i < 10; ++i ){
    if( i % 2 ){
      str += "<tr height=40 bgcolor=#FFCCCC>";
    }
    else{
      str += "<tr height=40 bgcolor=#CCFFFF>";
    }
    str +=
        "<td>" +
          // 問題番号
          ( i + 1 ) + "." +
        "</td>" +
        "<td>" +
          // 問題
          word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 ] +
        "</td>" +
        "<td>" +
          // 解答
          document.all.item( "ans" + i ).value;

          if( document.all.item( "ans" + i ).value.match( "^" + word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 + 1 ] + "$" ) ){ // 完全一致検出の神業
          // 正解だった場合、ポイントを加算
            point+=10;
          }
          else{
          // 間違っていた場合、正解を提示
          str +=
            "<span style=\"color:red\">" + "　→　" + word_db[ ( ( level - 1 ) * 100 + ( stage - 1 ) * 10 + i ) * 2 + 1 ] + "</span>";
          }
      str +=
        "</td>";
    if( i == 0 ){
      str +=
        "<td rowspan=10 align=center bgcolor=white>" +
          // 点数表示用の領域"point"
          "<span id=\"point\"></span><br><br><br>" +
          // [やり直す]
          "<a href=\"#\">" +
            "<img src=\"img/retry.gif\" onclick=\"remember(" + level + "," + stage + ")\"><br><br><br>" +
          "</a>" +
          // [次のステージ]
          "<a href=\"#\">";
      if( stage < 10 ){
        str +=
            "<img src=\"img/next.gif\" onclick=\"remember(" + level + "," + ( stage + 1 ) + ")\">";
      }
      else{
        if( level < (words/100) ){
          str +=
            "<img src=\"img/next.gif\" onclick=\"remember(" + ( level + 1 ) + "," + 1 + ")\">";
        }
        else{
        }
      }
      str +=
          "</a>" +
        "</td>";
    }
    str +=
      "</tr>";
  }
  //  過去最高得点を上回ったときにcookie書き換え
  if( point > pointdb[ ( level - 1 ) * 10 + stage - 1 ] ){
    pointdb[ ( level - 1 ) * 10 + stage - 1 ] = point;
    update_save_data( level, stage, point );
  }
  str += "<tr><td height=10></td></tr>";
  str +=
    "<tr>" +
      "<td colspan=3>" +
        "Ads by google" +
      "</td>" +
      "<td>" +
        "<a href=\"index.html\"><<<<トップページに戻る</a><br>" +
        "<a href=\"a5game.html\"><<<レベル一覧に戻る</a><br>" +
        "<a href=\"#\" onclick=\"init_menu(" + level + ")\">" +
          "<<ステージ一覧に戻る" +
        "</a><br>" +
        "<a href=\"#\" onclick=\"remember(" + level + "," + stage + ")\">" +
          "<単語一覧に戻る" +
        "</a>" +
      "</td>" +
    "</tr>";
  // マス幅指定
  str += "<tr><td width=100></td><td width=250></td><td width=250></td><td width=424></td>";
  str += "</table>";
  document.getElementById("tbl").innerHTML = str;
  document.getElementById("point").innerHTML = point + "点";
}
